/**********************************************************************
 * Title            tjpbase.h    	                              *
 * Programmer       Keith L. Doty                                     *
 * Date             May 03, 1999                                      *
 * Version          1.1 with servo drivers and ME11 modification      *
 *                                                                    *
 * Description							      *
 *   Collects include files and general constants into one file.      *
 **********************************************************************/

/*************************** Includes ********************************/

#include <analog.h>
#include <clocktjp.h>
#include <motorme.h>
#include <servome.h>
#include <serialtp.h>
#include <isrdecl.h>
#include <vectors.h>

/************************ End of Includes ****************************/

/**************************** Constants *********************************/
#define LEFT_MOTOR	0
#define RIGHT_MOTOR	1
#define MAX_SPEED      100
#define ZERO_SPEED       0

#define BUMPER     analog(0)
#define RIGHT_IR   analog(2)
#define LEFT_IR    analog(3)

#define START 	while(BUMPER<120)
#define FRONT_BUMP  (BUMPER>10)&&(BUMPER< 120)
#define BACK_BUMP  BUMPER>120

/* Enable OC4 interrupt and all servo operations */
#define SERVOS_ON     SET_BIT(TMSK1,0x10)             

/*Disable OC4 interrupt: Stops all servo holding torques, useful for energy savings*/
#define SERVOS_OFF    CLEAR_BIT(TMSK1, 0x10)

#define IRE_ON  *(unsigned char *)(0x7000) = 0x07
#define IRE_OFF	*(unsigned char *)(0x7000) = 0x00


/* VT100 clear screen */ 
#define CLEAR_SCREEN  printf("\x1b\x5B\x32\x4A\x04");

/* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
#define HOME_SCREEN   printf("\x1b[1;1H");





/************************ End of Constants ****************************/

