	.module servome4.c
	.dbfile servome4.c
	.area text
;  IX -> 0,x
;              i -> 2,x
_init_servome::
	jsr __enterb
	.byte 0x4
			sei

	.dbfile servome4.c
	.dbfunc init_servome
	.dbline 88
; /**********************************************************************
;  * 			MEKATRONIX Copyright 1998 		      *
;  * Title        servome.c  (Servo Drivers for TJ PRO)                 *
;  * Programmer   Keith L. Doty			                      *
;  * Date         May 07, 1999                                          *
;  * Version      1                                                     *
;  *                                                                    *
;   * Description: Servo drivers.					      *
; 	servo 0 on PA3 
; 	servo 1 on PA4 
; 	servo 2 on PA5 
; 	servo 3 on PA6 
; 	servo 4 on PA7
; 
; 	All pulse widths created in sequence, i.e., the five servos
; 	are phase shifted relative to one another by the pulse width 
; 	of the servo that preceeds it in the sequence.
; 
; 
;  * History:     Total revision					      *
;  **********************************************************************/
; 
; 
; /**************************** Includes **********************************/
; #include <hc11.h>
; #include <mil.h>
; /************************************************************************/
; 
; 
; /**************************** Constants *********************************/
; #define HALFPERIOD 16000     	// Refresh every 20 ms for each servo
; #define servo_hand  TOC4_isr
; #define NSERVO 5				//Number of servos
; #define NO_PULSE 1000			//Duration of a "zero pulse"
; /************************************************************************/
; 
; 
; /*************************** Prototypes *********************************/
; #pragma interrupt_handler TOC4_isr    /*Servo Handler*/
; void init_servome(void);
; 
; /*
;    servo() Arguments:
;    Servo# (0,1,2,3,4), Pulse Widths dictated by servo_limits[][]
;    For the ME11 board servos 2 and 3 are the left and right motors.
; */
; void servo(int, int);
; 
; void servo_hand(void);
; /************************************************************************/
; 
; 
; /***************************** Globals **********************************/
; /* servo_width[] is the on-time for each servo*/
; unsigned int previous_pwidth; servo_width[NSERVO]; 
; char servo_signal_state, servomask[NSERVO];
; unsigned int period_end;
; 
; extern unsigned int servo_limits[NSERVO][2];
; extern char srv_lim_default;
; /************************************************************************/
; 
; 
; 
; void init_servome(void)
; /************************************************************************
;  * Function: Initializes all necessary variables for the servos.        *
;  * Returns: None                                                        *
;  *                                                                      *
;  * Inputs                                                               *
;  *   Parameters: None                                                   *
;  *   Globals:    None                                                   *
;  *   Registers:  None                                                   *
;  * Outputs                                                              *
;  *   Parameters: None                                                   *
;  *   Globals:   servo_width[], servo_signal_state, servomask[],		*
;  *              current_servo_width       					*
;  *   Registers: TOC1, PORTB, TMSK1, TCTL1, PACTL                               *
;  * Functions called: None                                               *
;  * Notes: None                                                          *
;  ************************************************************************/
; {
;   int i;
;   
;   INTR_OFF();
;   
;   /*install interrupt handler on OC4*/
;   *((void (**)())0xffe2)  = servo_hand;
	ldd #_TOC4_isr
	std 0xffe2
	.dbline 90
;   
;   for(i=0; i<NSERVO; i++)
	ldd #0
	std 2,x
L3:
	.dbline 93
;   {
;   //Motors start turned off
;  	servo_width[i] = 0;
	ldd 2,x
	lsld
	addd #_servo_width
	xgdy
	ldd #0
	std 0,y
	.dbline 94
;  	previous_pwidth = 0;
	ldd #0
	std _previous_pwidth
	.dbline 97
; 
;   //Establish bit maps to control PortA outputs
; 	servomask[i] = 0x08<<i;
	ldd #8
	ldy 2,x
	cpy #0
	beq X0
X1:
	lsld
	dey
	bne X1
X0:
	pshb ; 
	psha ; spill
	ldd 2,x
	addd #_servomask
	xgdy
	pula ; 
	pulb ; reload
	stab 0,y
	.dbline 99
; 
;   }
L4:
	ldd 2,x
	addd #1
	std 2,x
	cpd #5
	blt L3
	.dbline 101
;      
;   TOC4 = 0;                       
	ldd #0
	std 0x101c
	.dbline 102
;   servo_signal_state = 0;
	clr _servo_signal_state
	.dbline 104
; 
;   SET_BIT(PACTL, 0x88);		   /* DDRA7 & DDRA3 set for output */
	ldy #0x1026
	bset 0,y,#136
	.dbline 105
;   SET_BIT(TMSK1,0x10);         /* Enable OC4 interrupt */
	ldy #0x1022
	bset 0,y,#16
			cli

	.dbline 107
;   INTR_ON();
; }
L2:
	inx
	inx
	inx
	inx
	txs
	pulx
	rts
;  IX -> 0,x
;              x -> 2,x
;       newwidth -> 10,x
;          index -> 6,x
_servo::
	jsr __enterb
	.byte 0x44
	.dbfunc servo
	.dbline 132
; 
; /************************ end init_servome ******************************/
; 
; 
; void servo(int index, int newwidth)
; /************************************************************************
;  * Function: Sets one of the servos to the speed defined by newwidth    *
; 			 Servo limits are checked. Default is no limit check.
;  * Returns: None                                                        *
;  *                                                                      *
;  * Inputs                                                               *
;  *   Parameters: index, newwidth                                        *
;  *   Globals:    None                                                   *
;  *   Registers:  None                                                   *
;  * Outputs                                                              *
;  *   Parameters: None                                                   *
;  *   Globals: servo_width[index]                                              *
;  *   Registers:  None                                                   *
;  * Functions called: None                                               *
;  * Notes: None                                                          *
;  ************************************************************************/
; {
;  unsigned int x;
;  
;   if(srv_lim_default == 1) //Check newwidth against default settings
	ldab _srv_lim_default
	cmpb #1
	bne L8
	.dbline 134
;   {
; 	x = servo_limits[index][0];
	ldd 6,x
	lsld
	lsld
	addd #_servo_limits
	xgdy
	ldd 0,y
	std 2,x
	.dbline 136
;   //Check lower servo limit  
; 	if(newwidth <= x) newwidth = x;
	ldd 10,x
	cpd 2,x
	bhi L10
	ldd 2,x
	std 10,x
L10:
	.dbline 138
; 	
; 	x = servo_limits[index][1];
	ldd 6,x
	lsld
	lsld
	addd #_servo_limits+2
	xgdy
	ldd 0,y
	std 2,x
	.dbline 140
;   //Check upper servo limit
; 	if(newwidth >= x) newwidth = x;
	ldd 10,x
	cpd 2,x
	blo L13
	ldd 2,x
	std 10,x
L13:
	.dbline 141
;   }
L8:
	.dbline 142
;   servo_width[index] = newwidth;
	ldd 6,x
	lsld
	addd #_servo_width
	xgdy
	ldd 10,x
	std 0,y
	.dbline 143
;   servo_order(index, newwidth);
	ldd 10,x
	pshb
	psha
	ldd 6,x
	jsr _servo_order
	puly
	.dbline 146
;   	  
; 
; }
L7:
	inx
	inx
	inx
	inx
	txs
	pulx
	puly
	rts
;  IX -> 0,x
;              i -> 2,x
;         pwidth -> 4,x
_TOC4_isr::
	jsr __enterb
	.byte 0x6
	.dbfunc TOC4_isr
	.dbline 187
; 
; /*********************** End servo ***********************************/
; 
; 
; 
; 
; 
; void servo_hand(void)
; /************************************************************************
;  * Function: Interrupt handler for servo signals.                       *
;  *	     Interrupt is OC4. Servo_0 is on PA3 and Servo_1 on PA4 and 	*
;  *           Servo_2 is on PA7.							*
;  * Returns: None                                                        *
;  *                                                                      *
;  * Inputs                                                               *
;  *   Parameters: None                                                   *
;  *   Globals:    servo_width[], servo_signal_state, servomask[], 		*
;  *               current_servo_width      					*
;  *   Registers:  None                                                   *
;  * Outputs                                                              *
;  *   Parameters: None                                                   *
;  *   Globals:    current_servo_width                                    *
;  *   Registers:  TOC4, PORTA, TFLG1                                     *
;  * Functions called: None                                               *
;  * Notes: None                                                          *
;  ************************************************************************/
; {
;   int i;
;   unsigned int pwidth;
; 
; /*
;    k=0,1,2,3,4: servo_signal_state = k -> Turn on servok, 
;    Increment TOC4 by servo_width[k]. Begin sequence again
;    a full servo period after start of servo 0 period.
;    
;    Assumption: Sum of the servo pulse widths < full servo period.
; 
; */
; 
; //Turn off previous servo, if exist and if on!
;   if((servo_signal_state != 0) && (previous_pwidth != 0))
	tst _servo_signal_state
	beq L16
	ldd _previous_pwidth
	beq L16
	.dbline 188
;     PORTA ^= servomask[servo_signal_state-1];
	ldab _servo_signal_state
	clra
	tstb
	bpl X2
	coma
X2:
	addd #_servomask-1
	xgdy
	; vol
	ldab 0x1000
	eorb 0,y
	stab 0x1000
L16:
	.dbline 191
;     
; //Mark the end of zero servo's period 	
;   if(servo_signal_state == 0) period_end = TOC4 + HALFPERIOD + HALFPERIOD;
	tst _servo_signal_state
	bne L19
	; vol
	ldd 0x101c
	addd #16000
	addd #16000
	std _period_end
L19:
	.dbline 195
; 
;   
; //Get pulse width of this servo
;   if(servo_signal_state < NSERVO)
	ldab _servo_signal_state
	cmpb #5
	bge L21
	.dbline 197
;   { 
; 	pwidth = servo_width[servo_signal_state];
	ldab _servo_signal_state
	clra
	tstb
	bpl X3
	coma
X3:
	lsld
	addd #_servo_width
	xgdy
	ldd 0,y
	std 4,x
	.dbline 198
; 	previous_pwidth = pwidth; //Save for next pass through
	ldd 4,x
	std _previous_pwidth
	.dbline 200
; 	
; 	if(pwidth == 0)
	ldd 4,x
	bne L23
	.dbline 201
; 	  TOC4 += NO_PULSE;   //No-pulse for 1ms!
	; vol
	ldd 0x101c
	addd #1000
	std 0x101c
	bra L24
L23:
	.dbline 203
;     else
;       TOC4 += pwidth;
	; vol
	ldd 0x101c
	addd 4,x
	std 0x101c
L24:
	.dbline 206
;   		
;   //Turn on this servo, if not zero pulse width
;     if(pwidth != 0)
	ldd 4,x
	beq L25
	.dbline 207
; 	  PORTA ^= servomask[servo_signal_state];
	ldab _servo_signal_state
	clra
	tstb
	bpl X4
	coma
X4:
	addd #_servomask
	xgdy
	; vol
	ldab 0x1000
	eorb 0,y
	stab 0x1000
L25:
	.dbline 208
;   }
L21:
	.dbline 210
;   
;   if(servo_signal_state == NSERVO)
	ldab _servo_signal_state
	cmpb #5
	bne L27
	.dbline 212
;   {
;    	TOC4 += period_end;
	; vol
	ldd 0x101c
	addd _period_end
	std 0x101c
	.dbline 213
;    	servo_signal_state = 0;
	clr _servo_signal_state
	.dbline 214
;   }
L27:
	.dbline 217
;   
; //Prepare for next servo access 
;   servo_signal_state++;
	inc _servo_signal_state
	.dbline 219
;   
;   CLEAR_FLAG(TFLG1,0x10);          /* Clear OC4I flag */
	ldy #0x1023
	bclr 0,y,#0xef
	.dbline 220
; }
L15:
	xgdx
	addd #6
	xgdx
	txs
	pulx
	rti
	.area bss
_period_end::
	.blkb 2
_servomask::
	.blkb 5
_servo_signal_state::
	.blkb 1
_servo_width::
	.blkb 10
_previous_pwidth::
	.blkb 2
